﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.IO;
using System.Windows.Forms;
using System.Diagnostics;

namespace uloha
{
    public delegate void Zmeneno();

    public struct Pozice
    {
        public int x, y;
        public char orientace;

        public override string ToString()
        {
            return x+" "+y+" "+orientace;
        }

        public static Pozice Vubec()
        {
            Pozice p = new Pozice();
            p.x = -1;
            p.y = -1;
            return p;
        }
        public bool Rovna(Pozice c)
        {
                return x == c.x && y == c.y && orientace == c.orientace;
        }
        public bool JeVubec() { return x < 0 && y < 0; }
        public Pozice(int a, int b) { x = a; y = b; orientace = 'N'; }
    }
    public class Hra
    {
        public Hra()
        {
        }

        public long id;
        public static string adresa = "localhost:8000";
        public const int len = 20;
        public char[,] policka;
        public const int ppoh = 9;
        public char[] pohyby;
        public bool started = false;
        public List<char> navoleno;
        public Pozice misto;
        public bool ai;

        public event Zmeneno HraZmenena;
        public Timer AITimer=null;

        public void Load(string request)
        {
            WebRequest wr = WebRequest.Create("http://" + adresa + "/"+request);
            StreamReader sr=(new StreamReader(wr.GetResponse().GetResponseStream()));
            string r = sr.ReadLine();
            try
            {
                id = long.Parse(r);
            }
            catch (Exception e)
            {
                started = false;
                if (AITimer != null) AITimer.Stop();
                if (HraZmenena != null) HraZmenena();
                MessageBox.Show(r);

                return;
            }
            policka = new char[len,len];
            for (int i=0;i<len;i++)
            {
                string str = sr.ReadLine();
                for (int y=0;y<len;y++) {
                    policka[y,i]=str[y];
                }
            }
            r = sr.ReadLine();
            string[] s = r.Split(new char[]{' '});
            misto.x = int.Parse(s[0])-1;
            misto.y = int.Parse(s[1])-1;
            misto.orientace = char.Parse(s[2]);
            pohyby = new char[ppoh];
            string l = sr.ReadLine();
            for (int i = 0; i < ppoh; i++)
            {
                pohyby[i] = l[i];
            }
            Trace.WriteLine("pozice = " + misto.x + " " + misto.y);

            navoleno = new List<char>();
            if (HraZmenena != null) HraZmenena();
        }

        public static char vpravo(char c)
        {
            switch (c)
            {
                case 'L': return 'N';
                case 'N': return 'R';
                case 'R': return 'D';
                case 'D': return 'L';
                default: throw new Exception();
            }
        }
        public static char vlevo(char c)
        {
            switch (c)
            {
                case 'L': return 'D';
                case 'N': return 'L';
                case 'R': return 'N';
                case 'D': return 'R';
                default: throw new Exception();
            }
        }

        public Pozice vpred(Pozice c)
        {
            if (c.Rovna(Pozice.Vubec())) return Pozice.Vubec();
            Pozice cn; cn.x = c.x; cn.y = c.y; cn.orientace = c.orientace;
            switch (cn.orientace)
            {
                case 'L': cn.x--; break;
                case 'R': cn.x++; break;
                case 'N': cn.y--; break;
                case 'D': cn.y++; break;
            }
            if (cn.x < 0 || cn.y < 0 || cn.x == 20 || cn.y == 20 || policka[cn.x, cn.y] == '#') return Pozice.Vubec();
            if (policka[c.x,c.y]=='$' || policka[cn.x, cn.y] == 'X') return c;
            return cn;
        }
        public Pozice vzad(Pozice c)
        {
            if (c.Rovna(Pozice.Vubec())) return Pozice.Vubec();
            Pozice cn; cn.x = c.x; cn.y = c.y; cn.orientace = c.orientace;
            switch (cn.orientace)
            {
                case 'L': cn.x++; break;
                case 'R': cn.x--; break;
                case 'N': cn.y++; break;
                case 'D': cn.y--; break;
            }
            if (cn.x < 0 || cn.y < 0 || cn.x == 20 || cn.y == 20 || policka[cn.x, cn.y] == '#') return Pozice.Vubec();
            if (policka[c.x, c.y] == '$' || policka[cn.x, cn.y] == 'X') return c;
            return cn;
        }

        public Pozice udelej(Pozice p, char c)
        {
            if (p.Rovna(Pozice.Vubec())) return Pozice.Vubec();
            switch (c)
            {
                case 'L':
                    {
                        p.orientace = vlevo(p.orientace);
                    }
                    break;
                case 'R':
                    p.orientace = vpravo(p.orientace);
                    break;
                case 'Z':
                    p = vzad(p);
                    break;
                case '1':
                    p = vpred(p);
                    break;
                case '2':
                    p = vpred(vpred(p));
                    break;
                case '3':
                    p = vpred(vpred(vpred(p)));
                    break;
            }
            if (p.Rovna(Pozice.Vubec())) return Pozice.Vubec();
            Pozice p2; p2.x = p.x; p2.y = p.y; p2.orientace = p.orientace;
            switch (policka[p.x, p.y])
            {
                case '^':
                    p2.y--;
                    break;
                case 'v':
                    p2.y++;
                    break;
                case '<':
                    p2.x--;
                    break;
                case '>':
                    p2.x++;
                    break;
            }
            if ( p2.x<0 || p2.y<0 || p2.x>=20 || p2.y>=20) return Pozice.Vubec();
            if (p2.x >= 0 && p2.y >= 0 && p2.x < 20 && p2.y < 20 && policka[p2.x, p2.y] != 'X') p = p2;
            if (policka[p.x, p.y] == '#') return Pozice.Vubec();
            return p;
        }

        public Pozice vyjdi(char[] navoleno)
        {
            Pozice p; p.x = misto.x; p.y = misto.y; p.orientace = misto.orientace;
            foreach (char c in navoleno)
            {
                p = udelej(p, c);
            }
            
            return p;
        }
        
        public Pozice najdikonec()
        {
            return vyjdi(navoleno.ToArray());
        }

        public void Start()
        {
            started = true;
            if (AITimer != null) AITimer.Stop();
            Load("start");
            if (ai)
            {
                AITimer = new Timer();
                AITimer.Tick += new EventHandler(AITimer_Tick);
                AITimer.Interval = 1000;
                AITimer.Start();
            }
            //HraZmenena();
        }

        int c = 0;
        bool aiWorking = false;
        void AITimer_Tick(object sender, EventArgs e)
        {
            if (c % 2 == 0 && navoleno.Count > 0) { aiWorking = false; Preposli(); }
            else if (!aiWorking) { aiWorking = true; AI(); }
            c = (c + 1) % 2;
        }

        public void Preposli()
        {
            string x = ""; foreach (char c in navoleno) x += c;
            string url = "kolo?id=" + id + "&pohyby=" + x;
            Trace.WriteLine(url);
            Load(url);
            //HraZmenena();
        }

        public char xmisto(int x, int y)
        {
            if (x == misto.x && y == misto.y) return misto.orientace;
            return policka[x, y];
        }

        char[] pf = { 'L', 'R', 'N', 'D', 'Z', '1', '2', '3' };
        int najdi(char x)
        {
            for (int i = 0; i < pf.Length; i++) if (pf[i] == x) return i;
            throw new Exception();
        }
        public bool jde(char[] x)
        {
            int[] pocty = new int[pf.Length];
            foreach (char c in pohyby)
            {
                pocty[najdi(c)]++;
            }
            foreach (char c in x)
            {
                pocty[najdi(c)]--;
                
            }
            foreach (int i in pocty) if (i < 0) return false;
            return true;
        }

        public List<char> PathFind(Pozice p)
        {
            char[] mov = new char[5];
            List<char> navoleno = new List<char>();
            for (int i = 0; i < Math.Pow(8, 5);i++)
            {
                int rr = 8;
                for (int y = 0; y < 5; y++)
                {
                    int tttt = (i % rr)/(rr/8);
                    //Trace.Write(tttt);
                    rr *= 8;
                    mov[y] = pf[tttt];
                }
                //Trace.WriteLine("");
                if (jde(mov))
                {
                    Pozice zz = vyjdi(mov);
                    string zzdasdf = "";
                    foreach (char c in mov) zzdasdf += c;
                    if (!zz.Rovna(Pozice.Vubec())) Trace.WriteLine(zzdasdf + "=>" + zz);
                    if (zz.x == p.x && zz.y == p.y && zz.orientace == p.orientace)
                    {
                        foreach (char xxxx in mov)
                        {
                            navoleno.Add(xxxx);
                        }
                        break;
                    }
                }

            }
            return navoleno;
        }

        public List<char[]> MoznePohyby()
        {
            List<char[]> mp = new List<char[]>();
            char[] mov = new char[5];
            List<char> navoleno = new List<char>();
            for (int i = 0; i < Math.Pow(8, 5); i++)
            {
                int rr = 8;
                for (int y = 0; y < 5; y++)
                {
                    int tttt = (i % rr) / (rr / 8);
                    //Trace.Write(tttt);
                    rr *= 8;
                    mov[y] = pf[tttt];
                }
                //Trace.WriteLine("");
                if (jde(mov))
                {
                    Pozice zz = vyjdi(mov);
                    string zzdasdf = "";
                    foreach (char c in mov) zzdasdf += c;
                    if (!zz.Rovna(Pozice.Vubec()))
                    {
                        mp.Add(mov);
                        mov = new char[5];
                    }
                }

            }
            return mp;
        }

        int[, ,] vzdalenosti;
        int[,] vzdalenosti2;

        public int rc(char c)
        {
            switch (c)
            {
                case 'N': return 0;
                case 'D': return 1;
                case 'L': return 2;
                case 'R': return 3;
            }
            throw new Exception();
        }

        struct PoziceA
        {
            public Pozice P;
            public bool[] brano;
        }

        public void rekalkulace(Pozice tgt)
        {
            vzdalenosti = new int[20, 20, 4];
            for (int i = 0; i < 20; i++) for (int y = 0; y < 20; y++) for (int z=0;z<4;z++)
                {
                    vzdalenosti[i, y,z] = 99999;
                }
            //vzdalenosti[poklad().x, poklad().y] = 0;
            vzdalenosti[tgt.x, tgt.y, rc(tgt.orientace)] = 0;

            Queue<PoziceA> prohledej = new Queue<PoziceA>();
            PoziceA initial; initial.P = tgt; initial.brano = new bool[pf.Length]; for (int i = 0; i < pf.Length; i++) initial.brano[i] = false;
            prohledej.Enqueue(initial);
            while (prohledej.Count > 0)
            {
                PoziceA ar = prohledej.Dequeue();
                Pozice r = ar.P;
                //Pozice[] yx = { new Pozice(r.x - 1, r.y), new Pozice(r.x + 1, r.y), new Pozice(r.x, r.y + 1), new Pozice(r.x, r.y - 1) };
                Pozice[] yx = new Pozice[pf.Length];
                int d = 0;
                for (int i = 0; i < pf.Length; i++) if (ar.brano[i]) d++;
                if (d>=5) { for (int i = 0; i < pf.Length; i++) ar.brano[i] = false; }
                for (int i = 0; i < pf.Length; i++)
                {
                    if (!ar.brano[i]) yx[i] = udelej(r, pf[i]);
                    else yx[i] = Pozice.Vubec();
                }

                for (int i=0;i<yx.Length;i++)
                {
                    Pozice p = yx[i];
                    if (!p.Rovna(Pozice.Vubec()) && vzdalenosti[p.x,p.y,rc(p.orientace)] > vzdalenosti[r.x,r.y,rc(r.orientace)]+1)
                    {
                        vzdalenosti[p.x, p.y,rc(p.orientace)] = vzdalenosti[r.x, r.y,rc(r.orientace)] + 1;
                        PoziceA nn; nn.P = p; nn.brano = new bool[pf.Length];
                        for (int ii = 0; ii < pf.Length; ii++) nn.brano[ii] = ar.brano[ii] || ii == i;
                        prohledej.Enqueue(nn);
                    }
                    /*
                    if (p.x >= 0 && p.y >= 0 && p.x < 20 && p.y < 20 && policka[p.x, p.y] != 'X' && policka[p.x, p.y] != '#' && 
                        vzdalenosti[p.x,p.y] > vzdalenosti[r.x,r.y]+1)
                    {
                    }
                     */
                }
            }
        }


        public void rekalkulace2(Pozice tgt)
        {
            vzdalenosti2 = new int[20, 20];
            for (int i = 0; i < 20; i++) for (int y = 0; y < 20; y++)
                    {
                        vzdalenosti2[i, y] = 99999;
                    }
            //vzdalenosti[poklad().x, poklad().y] = 0;
            vzdalenosti2[tgt.x, tgt.y] = 0;

            Queue<Pozice> prohledej = new Queue<Pozice>();
            prohledej.Enqueue(tgt);
            while (prohledej.Count > 0)
            {
                Pozice r = prohledej.Dequeue() ;
                Pozice[] yx = { new Pozice(r.x - 1, r.y), new Pozice(r.x + 1, r.y), new Pozice(r.x, r.y + 1), new Pozice(r.x, r.y - 1) };

                for (int i = 0; i < yx.Length; i++)
                {
                    if (yx[i].x < 0 || yx[i].y < 0 || yx[i].x >= 20 || yx[i].y >= 20 || policka[yx[i].x, yx[i].y] == '#' || policka[yx[i].x, yx[i].y] == 'X')
                        yx[i] = Pozice.Vubec();
                }
                /*Pozice[] yx = new Pozice[pf.Length];

                for (int i = 0; i < pf.Length; i++)
                {
                    yx[i] = udelej(r, pf[i]);
                }*/

                for (int i = 0; i < yx.Length; i++)
                {
                    Pozice p = yx[i];
                    if (!p.JeVubec() && vzdalenosti2[p.x, p.y] > vzdalenosti2[r.x, r.y] + 1)
                    {
                        vzdalenosti2[p.x, p.y] = vzdalenosti2[r.x, r.y] + 1;
                        prohledej.Enqueue(p);
                    }
                    /*
                    if (p.x >= 0 && p.y >= 0 && p.x < 20 && p.y < 20 && policka[p.x, p.y] != 'X' && policka[p.x, p.y] != '#' && 
                        vzdalenosti[p.x,p.y] > vzdalenosti[r.x,r.y]+1)
                    {
                    }
                     */
                }
            }
        }
        private Pozice poklad()
        {
            for (int i = 0; i < 20; i++) for (int y = 0; y < 20; y++)
                {
                    if (policka[i, y] == '$') return new Pozice(i, y);
                }
            throw new Exception();
        }

        public int minimum_vc()
        {
            int m = 99999;
            for (int i = 0; i < 4; i++) if (vzdalenosti[poklad().x, poklad().y, i] < m) m = vzdalenosti[poklad().x, poklad().y, i];
            return m;
        }
        public int minimum_vc2()
        {
            return vzdalenosti2[poklad().x, poklad().y];
        }

        public void AI2()
        {
            Trace.WriteLine("resorting to AI2...");

            char[] cil = null;
            rekalkulace2(misto);
            int vcil = minimum_vc2();
            foreach (char[] mov in MoznePohyby())
            {
                Pozice tgt = vyjdi(mov);
                rekalkulace2(tgt);
                if (vcil > minimum_vc2())
                {
                    cil = mov;
                    vcil = minimum_vc2();
                }
            }
            navoleno = new List<char>();
            if (cil == null)
            {
                for (int i = 0; i < 5; i++) navoleno.Add(pohyby[i]);
                Trace.WriteLine("What the bloody hell?!");
            }
            else
            {
                foreach (char c in cil) navoleno.Add(c);
            }
            HraZmenena();
        }

        public void AI()
        {
            char[] cil = null;
            rekalkulace(misto);
            int vcil = minimum_vc();
            foreach (char[] mov in MoznePohyby())
            {
                Pozice tgt = vyjdi(mov);
                rekalkulace(tgt);
                if (vcil > minimum_vc()) {
                    cil=mov;
                    vcil = minimum_vc();
                }
            }
            navoleno = new List<char>();
            if (cil == null)
            {
                AI2();
            }
            else
            {
                foreach (char c in cil) navoleno.Add(c);
                HraZmenena();
            }
        }
    }
}
