﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace uloha
{
    public partial class HraControl : UserControl
    {
        Hra h;
        Button[] cbs;
        bool[] aktivni; Button bx;
        public HraControl()
        {
            InitializeComponent();
            cbs = new Button[9];
            aktivni = new bool[9];
            for (int i = 0; i < 9; i++)
            {
                aktivni[i] = false;
                cbs[i] = new Button();
                cbs[i].Location = new Point(i * 40, Height - 20);
                cbs[i].Size = new Size(40, 20);
                int r = i;
                cbs[i].Click += new EventHandler((a, b)
                => { kliknuto(r); });

                this.Controls.Add(cbs[i]);
                cbs[i].Show();
            }
            bx = new Button();
            bx.Location = new Point(Width - 100, Height - 20);
            bx.Size = new Size(100, 20);
            bx.Text = "Zrušit tah";
            bx.Enabled = false;
            bx.Click += new EventHandler(b_Click);
            Controls.Add(bx);
            bx.Show();

            nor.SelectedIndex = 0;
        }

        void b_Click(object sender, EventArgs e)
        {
            h.navoleno = new List<char>();
            Invalidate();
        }

        void kliknuto(int i)
        {
            if (!aktivni[i])
            {
                aktivni[i] = true;
                h.navoleno.Add(cbs[i].Text[0]);
                cbs[i].Text = "(" + h.navoleno.Count+": " + cbs[i].Text + ")";
                cbs[i].Enabled = false;
                Invalidate();
            }

            if (h.navoleno.Count == 5)
            {
                if (h.najdikonec().JeVubec())
                {
                    MessageBox.Show("Cesta je spatne vybrana, musite jit jinudy!");
                } else
                h.Preposli();
            }
        }

        public void RedoX()
        {
            nx.Enabled = h.started && !h.ai;
            ny.Enabled = h.started && !h.ai;
            nor.Enabled = h.started && !h.ai;
            bx.Enabled = h.started && !h.ai;
            button2.Enabled = h.started && !h.ai;
            if (h.started)
                for (int i = 0; i < 9; i++)
                {
                    aktivni[i] = false;
                    cbs[i].Text = h.pohyby[i].ToString();
                    cbs[i].Enabled = !h.ai;
                }
            else for (int i = 0; i < 9; i++) cbs[i].Enabled = false;
        }

        public void Nastav(Hra hra)
        {
            h = hra;
            h.HraZmenena += new Zmeneno(() => { this.Invoke(new MethodInvoker(() => {
                RedoX();
                Invalidate();
            })); });
        }

        private void HraControl_Paint(object sender, PaintEventArgs e)
        {
            if (h == null) return;
            if (!h.started) return;
            Graphics g=e.Graphics;
            Pozice p = h.najdikonec();
            int px = 0, py = 0;
            for (int i = 0; i < Hra.len; i++)
            {
                for (int y = 0; y < Hra.len; y++)
                {
                    switch (h.xmisto(i, y))
                    {
                        case 'X':
                            g.FillRectangle(Brushes.Black,  new Rectangle(20 * i, 20 * y, 20, 20));
                            break;
                        case '.':
                            g.FillRectangle(Brushes.White, new Rectangle(20 * i, 20 * y, 20, 20));
                            break;
                        case '#':
                            g.FillRectangle(Brushes.Red, new Rectangle(20 * i, 20 * y, 20, 20));
                            break;
                        case '$':
                            g.FillRectangle(Brushes.Orange, new Rectangle(20 * i, 20 * y, 20, 20));
                        Font f = new Font("Arial", 14.0f, FontStyle.Bold);
                        SizeF s = g.MeasureString("$", f);
                        g.DrawString("$", f, Brushes.Yellow, new PointF(20 * i + 10 - s.Width / 2, 20 * y + 10 - s.Height / 2));
                            break;
                        case 'L':
                        case 'R':
                        case 'D':
                        case 'N':
                            g.FillRectangle(Brushes.Blue, new Rectangle(20 * i, 20 * y, 20, 20));
                            px = 0; py=0;
                switch (h.misto.orientace)
                {
                    case 'L': px--; break;
                    case 'R': px++; break;
                    case 'N': py--; break;
                    case 'D': py++; break;
                } g.DrawLine(new Pen(Color.Yellow, 5.0f), new Point(20 * i + 10, 20 * y + 10), new Point(20 *i + 10 + 10 * px, 20 * y + 10 + 10 * py));
                            break;
                        case '<':
                            g.FillRectangle(Brushes.White, new Rectangle(20 * i, 20 * y, 20, 20));
                            g.DrawLine(Pens.Black, new Point(20 * i + 18, 20 * y + 10), new Point(20 * i+2, 20 * y + 10));
                            g.DrawLine(Pens.Black, new Point(20 * i + 7, 20 * y + 15), new Point(20 * i+2, 20 * y + 10));
                            g.DrawLine(Pens.Black, new Point(20 * i + 7, 20 * y + 5), new Point(20 * i+2, 20 * y + 10));
                            break;
                        case '>':
                            g.FillRectangle(Brushes.White, new Rectangle(20 * i, 20 * y, 20, 20));
                            g.DrawLine(Pens.Black, new Point(20 * i + 18, 20 * y + 10), new Point(20 * i + 2, 20 * y + 10));
                            g.DrawLine(Pens.Black, new Point(20 * i + 13, 20 * y + 15), new Point(20 * i + 18, 20 * y + 10));
                            g.DrawLine(Pens.Black, new Point(20 * i + 13, 20 * y + 5), new Point(20 * i + 18, 20 * y + 10));
                            break;
                        case '^':
                            g.FillRectangle(Brushes.White, new Rectangle(20 * i, 20 * y, 20, 20));
                            g.DrawLine(Pens.Black, new Point(20 * i + 10, 20 * y + 2), new Point(20 * i + 10, 20 * y + 18));
                            g.DrawLine(Pens.Black, new Point(20 * i + 10, 20 * y + 2), new Point(20 * i + 5, 20 * y + 13));
                            g.DrawLine(Pens.Black, new Point(20 * i + 10, 20 * y + 2), new Point(20 * i + 15, 20 * y + 13));
                            break;
                        case 'v':
                            g.FillRectangle(Brushes.White, new Rectangle(20 * i, 20 * y, 20, 20));
                            g.DrawLine(Pens.Black, new Point(20 * i + 10, 20 * y + 18), new Point(20 * i + 10, 20 * y + 2));
                            g.DrawLine(Pens.Black, new Point(20 * i + 10, 20 * y + 18), new Point(20 * i + 5, 20 * y + 7));
                            g.DrawLine(Pens.Black, new Point(20 * i + 10, 20 * y + 18), new Point(20 * i + 15, 20 * y + 7));
                            break;
                        default:
                            g.DrawRectangle(Pens.Blue, new Rectangle(20 * i, 20 * y, 20, 20));
                            g.DrawString(h.xmisto(i, y).ToString(), DefaultFont, Brushes.Black, new PointF(20 * i, 20 * y));
                            break;

                    }
                }
            }
            px = 0; py = 0;
            if (!p.Rovna(h.misto))
            {
                Pozice pp = h.misto;
                for (int i = 0; i < h.navoleno.Count - 1; i++)
                {
                    pp = h.udelej(pp, h.navoleno[i]);
                    Font f = new Font("Arial", 14.0f, FontStyle.Bold);
                    SizeF s = g.MeasureString((i + 1).ToString(), f);
                    g.DrawString((i + 1).ToString(), f, Brushes.Red, new PointF(20 * pp.x + 10 - s.Width / 2, 20 * pp.y + 10 - s.Height / 2));
                }
                if (!p.Rovna(Pozice.Vubec()))
                {

                    g.FillRectangle(Brushes.Yellow, new Rectangle(20 * p.x, 20 * p.y, 20, 20));
                    switch (p.orientace)
                    {
                        case 'L': px--; break;
                        case 'R': px++; break;
                        case 'N': py--; break;
                        case 'D': py++; break;
                    } g.DrawLine(new Pen(Color.Green, 5.0f), new Point(20 * p.x + 10, 20 * p.y + 10), new Point(20 * p.x + 10 + 10 * px, 20 * p.y + 10 + 10 * py));
                }
                else
                {
                    g.DrawString("Chybna posloupnost!", DefaultFont, Brushes.Red, new PointF(20, 410));
                }
                }

            for (int i = 0; i < 20; i++) g.DrawLine(Pens.Gray, new Point(i * 20, 0), new Point(i * 20, 400));
            for (int i = 0; i < 20; i++) g.DrawLine(Pens.Gray, new Point(0,i * 20), new Point(400,i * 20));
        }

        private void HraControl_Load(object sender, EventArgs e)
        {

        }

        private void button2_Click(object sender, EventArgs e)
        {
            Pozice p;
            p.x = (int)nx.Value-1; p.y=(int)ny.Value-1; p.orientace=((string)nor.SelectedItem)[0];
            List<char> pf = h.PathFind(p);
            if (pf.Count > 0)
            {
                h.navoleno = pf;
                h.Preposli();
            }
            else
            {
                MessageBox.Show("To nejde...");
            }
        }
    }
}
